package com.abi.qms.platform.service.impl;

import com.abi.qms.platform.dao.entity.BaseSapMaterial;
import com.abi.qms.platform.dao.mapper.BaseSapMaterialMapper;
import com.abi.qms.platform.dto.req.*;
import com.abi.qms.platform.dto.res.*;
import com.abi.qms.platform.service.SapBaseQueryService;
import com.abi.task.common.utils.PojoConverterUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * sap基础数据查询
 * </p>
 *
 * @author Andy.Tan
 */
@Service
public class SapBaseQueryServiceImpl implements SapBaseQueryService {

    @Autowired
    private BaseSapMaterialMapper baseSapMaterialMapper;

    /**
     * 查询SAP物料列表
     **/
    @Override
    public ListSapMaterialRes listSapMaterial(ListSapMaterialReq req) {
        //查询
        QueryWrapper<BaseSapMaterial> sapMaterialQw = new QueryWrapper<>();
        sapMaterialQw.eq(StringUtils.isNotBlank(req.getSapMaterialId()),"sap_material_id",req.getSapMaterialId());
        List<BaseSapMaterial> sapMaterialList = baseSapMaterialMapper.selectList(sapMaterialQw);

        //构造出参
        ListSapMaterialRes res = new ListSapMaterialRes();
        List<ListSapMaterialRes.SapMaterialBean> sapMaterialBeanList = PojoConverterUtils.copyList(sapMaterialList, ListSapMaterialRes.SapMaterialBean.class);
        res.setSapMaterialBeanList(sapMaterialBeanList);

        return res;
    }

    /**
     * 查询SAP包材场列表
     **/
    @Override
    public ListSapCoverFactoryRes listSapCoverFactory(ListSapCoverFactoryReq listSapCoverFactoryReq) {
        //TODO
        return null;
    }

    /**
     * 查询SAP啤酒厂列表
     **/
    @Override
    public ListSapBeerFactoryRes listSapBeerFactory(ListSapBeerFactoryReq listSapBeerFactoryReq) {
        //TODO
        return null;
    }

    /**
     * 查询SAP订单列表
     **/
    @Override
    public ListSapCodePackageOrderRes listSapCodePackageOrder(ListSapCodePackageOrderReq listSapCodePackageOrderReq) {
        //TODO
        return null;
    }

    /**
     * 查询SAP订单关联的QMS物料列表
     **/
    @Override
    public ListMatertialBySapOrderRes listMaterialBySapOrder(ListMaterialBySapOrderReq listMaterialBySapOrderReq) {
        //TODO
        return null;
    }



}
